unit base_n;   { uwe.sieber@gmx.de }

interface
FUNCTION ByteToHex(h:Byte):String;    {- converts a byte to 2 hex chars}
FUNCTION WordToHex(h:Word):String;    {- converts a word to 4 hex chars}
function BCDtoBYTE(wert: byte): byte;
function BYTEtoBCD(wert: byte): byte;
function ByteToBin(wert:byte):string;
function BinToByte(wert: string): byte;
function HexToWord(h: string):Word;
function HexToByte(h: string):Byte;


implementation

FUNCTION ByteToHex(h:Byte):String;    {- converts a byte to 2 hex chars}
CONST
	HexArray:ARRAY[0..15] OF Char = '0123456789ABCDEF';
BEGIN
	ByteToHex:=HexArray[h SHR 4]+HexArray[h AND $F];
END;

FUNCTION WordToHex(h:Word):String;    {- converts a word to 4 hex chars}
BEGIN
	WordToHex:=ByteToHex(Hi(h))+ByteToHex(Lo(h));
END;

function HexToByte(h: string):byte;
var
	err: integer;
	wert: byte;
begin
	if copy(h,1,1)='$' then
		val(h,wert,err)
	else begin
		h:='$'+h;
		val(h,wert,err)
	end;
	hextobyte:=wert;
end;

function HexToWord(h: string):Word;
var
	err: integer;
	wert: word;
begin
	if copy(h,1,1)='$' then
		val(h,wert,err)
	else begin
		h:='$'+h;
		val(h,wert,err)
	end;
	hextoword:=wert;
end;

function BCDtoBYTE(wert: byte): byte;
begin
	bcdtobyte:=(wert shr 4)*10+(wert and 15);
end;

function BYTEtoBCD(wert: byte): byte;
begin
	{$R+}
	bytetobcd:=(trunc(wert/10) shl 4)+(wert-trunc(wert/10)*10);
	{$R-}
end;

function ByteToBin(wert:byte):string;
var
	l, basis: byte;
	s: string[9];
begin
	s:=''; basis:=128;
	for l:=1 to 8 do begin
		if l=5 then s:=s+'.';
		if wert and basis >0 then
			s:=s+'1'
		else
			s:=s+'0';
		basis:= basis shr 1;
	end;
	bytetobin:=s;
end;

function BinToByte(wert: string): byte;
var
	l,basis,b: byte;
begin
	b:=0; basis:=128;
	while length(wert)<8 do wert:='0'+wert;
	for l:=1 to 8 do begin
		if wert[l]='1' then
			b:=b+basis;
		basis:=basis shr 1;
	end;
	bintobyte:=b;
end;

begin
end.
