program pci2errl;  { uwe.sieber@gmx.de }
uses base_n;
var
	i, d, v: word;
	p: string;
	res: integer;
	b: byte;
	
procedure errMsg;
begin
	writeln('invalid parameters');
	writeln('pci2errl device_id vendor_id');
	writeln('gives errorlevel 1 when device is''n found in your system');
	writeln('');
	halt(2);
end;

begin
	if paramcount<> 2 then begin
		errmsg;
	end;
	val('$'+paramstr(1), d, res);
	if res<>0 then begin
		errmsg;
	end;
	val('$'+paramstr(2), v, res);
	if res<>0 then begin
		errmsg;
	end;
	
	asm
		mov ax, 0b101h {pci bios present}
		int 1ah
		mov b, 1
		jc @noPCIbios
		mov b, 0
@noPCIbios:
	end;
	if b=1 then begin
		halt(1);
	end;
	
	asm
		mov ax, 0b102h {find pci device}
		mov cx, d
		mov dx, v
		mov si, 0
		int 1ah
		
		mov b, 1
		jc @notFound
		mov b, 0
@notFound:
	end;
	
	if b=0 then
		writeln('Device ', wordTohex(d), 'h found')
	else
		writeln('Device ', wordTohex(d), 'h NOT found');
	halt(b);
	
end.
