Program PCISet;  { uwe.sieber@gmx.de }
uses dos,PCIunit, base_n, xms;

var
	func,revision,res:byte;

	newval, oldval, reg, mask, b, v:  byte;
	busdev, seg, ofs, dev, ven: word;
	x: longint;
	s: string;
	i: integer;

Procedure CLI; inline ($FA);
Procedure STI; inline ($FB);
procedure FlushCache2;
begin
for seg:=0 to 65535 do
	for ofs:=0 to 3 do
		x:=meml[seg:ofs*4];
end;

function GetRegByte(busdev: word; reg: word): byte;
var b: byte;
begin
	asm
		mov ax, 0b108h  { read byte }
		mov bx, busdev
		mov di, reg
		int 1ah
		mov b, cl
	end;
	GetRegByte:=b;
end;

procedure SetRegByte(busdev: word; reg: word; v: byte);
begin
	asm
		mov ax, 0b10Bh  { write byte }
		mov bx, busdev
		mov cl, v
		mov di, reg
		int 1ah
	end;
end;

procedure FlushCache;
var xh1, xh2: word;
begin
	if not xmsThere then
		FlushCache2
	else begin
		if XmsKBytesAvail >= 2048 then begin
			xh1 := AllocateXmsBlock(1024);
			xh2 := AllocateXmsBlock(1024);
			MoveInXMS(1024, xh1, 0, xh1, 0);
			if not (DeAllocateXMSHandle(xh1)) then writeln(XmsErrorCode);
			if not (DeAllocateXMSHandle(xh2)) then writeln(XmsErrorCode);
		end;
	end;
end;



begin

	writeln;
	writeln('Chip-Setter zu direkten nderung von PCI-Registern der Host-Bridge');
	writeln('(c) 1998-99 Uwe Sieber');
	writeln('Know How aus c''t magazin fr computertechnik');

	writeln;
	if paramcount <> 5 then begin
		if pos('?',paramstr(1)) = 0 then
			writeln('falsche Parameterzahl!');
		writeln;
		writeln('setpci device-id vendor-id index maske wert');
		writeln('          HEX       HEX     HEX   BIN  BIN');
		writeln;
		halt(1);
	end;

	dev:=hextoword(paramstr(1));
	ven:=hextoword(paramstr(2));
	reg:=hextobyte(paramstr(3));
	mask:=bintobyte(paramstr(4));
	v:=bintobyte(paramstr(5));

	asm
		mov ax, 0b101h {pci bios present}
		int 1ah
		mov b, 1
		jc @noPCIbios
		mov b, 0
		@noPCIbios:
	end;
	if b=1 then begin
		writeln('No PCI BIOS found, program halted'); writeln;
		halt(1);
	end;
	
	asm
		mov ax, 0b102h {find pci device}
		mov cx, dev
		mov dx, ven
		mov si, 0
		int 1ah
		
		mov busdev, bx
		
		mov b, 0
		jc @notFound
		mov b, 1
		@notFound:
	end;
	
	if b=0 then begin
		writeln('Device ', wordTohex(dev), 'h of Vendor ', wordToHex(ven), 'h NOT found');
		halt(1);
	end;
	
	
{directvideo:=false;}

	oldval:=GetRegByte(busdev, reg);
	
	writeln('vorher :      ',bytetohex(reg),'h: ',bytetobin(oldval));

	newval:=oldval AND NOT mask;
	v:=v and mask;
	newval:=newval OR v;

	cli;
	FlushCache;
	SetRegByte(busdev, reg, newVal);
	FlushCache;
	sti;
	
	newval:=GetRegByte(busdev, reg);
	write('nachher:      ',bytetohex(reg),'h: ',bytetobin(newval));
	writeln;
end.
